#ifndef _INCLUDE_TITANIUM_LOCAL_BANE_H_
#define _INCLUDE_TITANIUM_LOCAL_BANE_H_


#include <fstream>
#include <string>
#include "solution.h"


class LocalBaneVar;


class LocalBaneSolver {
public:
  void identicalTo(  const LocalBaneVar &, const LocalBaneVar & );
  void mustBeGlobal( const LocalBaneVar & );
  void subsumedBy(   const LocalBaneVar &, const LocalBaneVar & );

  LocalSolution solution();

protected:
  LocalBaneSolver();

private:
  ofstream constraints;
  static void configure( ios & );
  static string input();
  static string output();
};


#endif // !_INCLUDE_TITANIUM_LOCAL_BANE_H_
