#include "AST.h"
#include "decls.h"


void TreeNode::localReportChange( const string &context,
				  const TypeNode &type ) const
{
  message( context + " : <" + type.typeName() + '>' );
}


////////////////////////////////////////////////////////////////////////


void MethodNode::localReportChange( const char *context ) const
{
  TreeNode::localReportChange( decl()->errorName() + ' ' + context,
			       *decl()->type() );
}
