#ifndef _INCLUDE_ARRAY_ADDR_H_
#define _INCLUDE_ARRAY_ADDR_H_

#include "java_array_methods.h"
#include "ti-memory.h"
#include "titanium.h"


#define JAVA_ARRAY_ADDR_( form, result, array, index )	\
  do {							\
    JAVA_ARRAY_CHECK_ ## form ( (array), (index), 1 );	\
    FIELD_ADDR_ ## form ( (result), (array), data[0] );	\
    INDEX_ ## form ( (result), (result), (index) );	\
  } while (0)

#define JAVA_ARRAY_ADDR_GLOBAL( result, array, index )  JAVA_ARRAY_ADDR_( GLOBAL, result, array, index )
#define JAVA_ARRAY_ADDR_LOCAL(  result, array, index )  JAVA_ARRAY_ADDR_( LOCAL,  result, array, index  )


#define TI_ARRAY_ADDR_( form, elem, arity )   TI_ARRAY_ADDR_ ## form ## _ ## elem ## _ ## arity
#define TI_ARRAY_ADDR_GLOBAL( elem, arity )   TI_ARRAY_ADDR_( GLOBAL, elem, arity )
#define TI_ARRAY_ADDR_LOCAL(  elem, arity )   TI_ARRAY_ADDR_( LOCAL,  elem, arity )


#endif /* !_INCLUDE_ARRAY_ADDR_H_ */
