#include <stdlib.h>
#include "fp-utils.h"
#include "gc.h"
#include "java_array.h"
#include "linkage.h"
#include "native-str-utils.h"

#include "T21NumberFormatException4lang4java.h"
#include "layout!PT21NumberFormatException4lang4java.h"
#include "T6String4lang4java.h"
#include "layout!PT6String4lang4java.h"


typedef    T21NumberFormatException4lang4java    NumExcept;
typedef PT21NumberFormatException4lang4java GP_NumExcept;


void tossNumberFormatException( GP_JString message )
{
  NumExcept * const newbie = (NumExcept *) ti_malloc( sizeof( NumExcept ) );
  GP_NumExcept exception;
  
  m21NumberFormatExceptionPT6String4lang4javamT21NumberFormatException4lang4java(
	newbie, message );

  globalize( exception, newbie );
  THROW( exception );
}


jdouble stringToDouble( GP_JString str )
{
  const jint length = m6lengthmT6String4lang4java( str );
  if (!length)
    tossNumberFormatException( str );
  else
    {
      const char * const begin = globalJstringToCstring( str );
      char *end;
      const jdouble result = strtod( begin, &end );

      if (end - begin == length)
	return result;
      else
	tossNumberFormatException( str );
    }
}


PT6String4lang4java doubleToString( jdouble value )
{
    PT6String4lang4java result;
    
    char buffer[ 32 ];
    g_fmt( buffer, value );
    
    globalize( result, java_string_build_8( buffer ) );
    return result;
}
