#include "gc.h"
#include "mem-local.h"
#include "native-utils.h"

#include "T30ArrayIndexOutOfBoundsException4lang4java.h"
#include "T20NullPointerException4lang4java.h"
#include "layout!PT30ArrayIndexOutOfBoundsException4lang4java.h"
#include "layout!PT20NullPointerException4lang4java.h"
#include "layout!T30ArrayIndexOutOfBoundsException4lang4java.h"


typedef T20NullPointerException4lang4java NullExcept;
typedef PT20NullPointerException4lang4java GP_NullExcept;
typedef T30ArrayIndexOutOfBoundsException4lang4java ArrayExcept;
typedef PT30ArrayIndexOutOfBoundsException4lang4java GP_ArrayExcept;


void tossNullPointerException()
{
    GP_NullExcept exception;
    NullExcept * const newbie = (NullExcept *) ti_malloc( sizeof( NullExcept ) );
    m20NullPointerExceptionmT20NullPointerException4lang4java( newbie );

    globalize( exception, newbie );
    THROW( exception );
}


void checkArrayBounds( jint trustedMax, jint offset, jint length )
{
    if (offset < 0 || length < 0 || offset + length > trustedMax) {
	GP_ArrayExcept exception;
	ArrayExcept * const newbie = (ArrayExcept *) ti_malloc( sizeof( ArrayExcept ) );
	m30ArrayIndexOutOfBoundsExceptionmT30ArrayIndexOutOfBoundsException4lang4java( newbie );

	globalize( exception, newbie );
	THROW( exception );
    }
}
