#ifndef _INCLUDE_TITANIUM_CONFIG_H_
#define _INCLUDE_TITANIUM_CONFIG_H_

@TOP@

/* self-identification */
#undef PACKAGE
#undef VERSION

/* Local qualification inference */
#undef USE_LOCAL_INFERENCE

/* Sglobal inference */
#undef USE_SGLOBAL_INFERENCE

/* Disable GC */
#undef USE_GC_NONE

/* Inline modifier supported at runtime */
#undef USE_RUNTIME_INLINE

/* Variable sized stack arrays at runtime */
#undef USE_RUNTIME_VARARRAY

/* Types for primitive types in inttypes.h */
#undef USE_RUNTIME_INTTYPES_H

/* MAXPATHLEN is defined in sys/param.h */
#undef USE_RUNTIME_SYS_PARAM_H_MAXPATHLEN

/* PATHSIZE and not MAXPATHLEN is defined in sys/param.h */
#undef USE_RUNTIME_SYS_PARAM_H_PATHSIZE

/* Using the GNU C compiler for the Cray at runtime */
#undef USE_RUNTIME_CRAY_GNU_C

/* Experimental new Java array support */
#undef USE_NEW_ARRAYS

/* C++ string class has erase() methods */
#undef HAVE_STRING_ERASE

/* C++ queue and stack templates take two type parameters */
#undef HAVE_BINARY_ADAPTORS

/* C++ template specialization syntax */
#undef HAVE_TEMPLATE_SPECIALIZATION

/* C++ string class requires inclusion of <std/bastring.cc> */
#undef HAVE_STD_BASTRING_CC

/* C++ character traits template class is called "char_traits" */
#undef HAVE_CHAR_TRAITS

/* C++ character traits template class can be specialized implicitly */
#undef IMPLICIT_CHAR_TRAITS

/* C++ stream state set using ios::setstate() */
#undef HAVE_IOS_SETSTATE

@BOTTOM@

#ifdef HAVE_FEATURES_H
# include <features.h>
#endif

/* special GCC features */
#if ! defined (__GNUC__) && ! defined (__attribute__)
#define __attribute__(flags)
#endif

#endif
