#include <fstream>
#include "../IncludeOnce.h"
#include "../c-types/CtType.h"
#include "CfCode.h"
#include "CfNeeds.h"


CfCode::CfCode( const CtType &type, char suffix )
  : CfFile( type.name, suffix )
{
}


CfCode::CfCode( const string &basename, char suffix )
  : CfFile( basename, suffix )
{
}


CfCode::~CfCode()
{
  CfNeeds needs( *this );
  defineAll( needs );
}


void CfCode::includeNeeds()
{
  include( CfNeeds::deriveName( *this ) );
}


// Local Variables:
// c-file-style: "gnu"
// End:
