#if defined(HAVE_INTTYPES_H)
#  include <inttypes.h>
#  define Long int32_t
#  define ULong uint32_t
#  define Llong int64_t
#  define ULLong uint64_t
#else /* defined(HAVE_INTTYPES_H) */
/* Assumes: long is 32-bit integer, long long is 64-bit integer */
#  define Long long
#  define ULong unsigned long
#  define Llong long long
#  define ULLong unsigned long long
#endif /* defined(HAVE_INTTYPES_H) */

#include "runtime/fp-utils/dtoa-uniproc.c"
