#ifndef _INCLUDE_TITANIUM_LOCAL_BANE_VAR_H_
#define _INCLUDE_TITANIUM_LOCAL_BANE_VAR_H_


#include <iosfwd>
#include <set>
#include "using-std.h"

class TreeNode;
class TypeNode;
class AllocateArrayDimensionNode;


class LocalBaneVar
{
public:
  LocalBaneVar();
  const TreeNode &toNode() const;

protected:
  LocalBaneVar( const TreeNode & );

private:
  const TreeNode *node;
  static set< const TreeNode *, less< const TreeNode * > > known;

  friend ostream & operator << ( ostream &, const LocalBaneVar & );
  friend istream & operator >> ( istream &, LocalBaneVar & );
};


ostream & operator << ( ostream &, const LocalBaneVar & );
istream & operator >> ( istream &, LocalBaneVar & );


#endif // !_INCLUDE_TITANIUM_LOCAL_BANE_VAR_H_
