#include "AST.h"


void MethodCallNode::localRebind() const
{
  // This is a really shoddy approximation to resolveName().
  
  const TypeNode &dispatcher = *method()->accessedObjectType();
  const bool wantLocal = dispatcher.isLocal();
  Decl *acceptable = 0;
  Decl *best = 0;

  foriter (replacement, dispatcher.decl()->environ()->lookupFirst( decl()->name(), Decl::Method ), EnvironIter)
    {
      acceptable = &*replacement;
      if (replacement->type()->isLocal() == wantLocal)
	best = &*replacement;
    }

  if (acceptable)
    method()->simpName()->decl( best ? best : acceptable );
  else
    fatal( "could not update name binding" );
}
