static long /* single */ STATIC_DEF(nextSharedId);

void m7barriermT2Ti4lang2ti(void);

#ifndef BACKEND_UNIPROC
#define MAXSREGIONS 1024
Region STATIC_DEF(__sregionidmap[MAXSREGIONS]);
#endif

struct T12SharedRegion4lang2ti *newsregion(void)
{
  struct T6Region4lang2ti *r = newregion();
  struct T12SharedRegion4lang2ti *sr = (struct T12SharedRegion4lang2ti *)r;

  m12SharedRegionmT12SharedRegion4lang2ti(sr);
  STATIC_REF(nextSharedId) += 2;
  r->id = STATIC_REF(nextSharedId) + 1;
  initregion(r);
#ifndef BACKEND_UNIPROC
  if ((r->id >> 1) >= MAXSREGIONS) abort();
  STATIC_REF(__sregionidmap[r->id >> 1]) = (Region)r;
#endif

  /* Synchronise to ensure that all procs have created the region
     before any proc returns (otherwise races are possible where
     one process sees objects in a not-yet-created-locally
     shared region) */
  m7barriermT2Ti4lang2ti();

  return sr;
}

void m6deletemT12SharedRegion4lang2ti(PT12SharedRegion4lang2ti me)
{
  /* Make sure we get the local representative of the region */
  Region r = MyGRegion(*(GRegion*)&me);

  /* Don't start freeing memory before everyone gets here */
  m7barriermT2Ti4lang2ti();

  deleteregion(r);
}
