#ifndef __REGION_STRUCT
#define __REGION_STRUCT


typedef unsigned long uint32;


struct ti5cdescmT6Region4lang2ti;
struct page;
struct titanium_monitor_t;

struct ablock {
  char *base;
  uint32 allocfrom;
};

struct allocator {
  struct ablock page;
  struct ablock superpage;
  struct ablock hyperpage;
  struct page *pages;
  struct page *bigpages;
};

typedef struct T6Region4lang2ti {
  struct ti5cdescmT6Region4lang2ti *class_info;
  void (**intf_info)();
  struct titanium_monitor_t *monitor;
  long rc;
  struct allocator normal;
  struct allocator atomic;
  uint32 id;
  struct T6Region4lang2ti *previous;
  struct T6Region4lang2ti *next;
  uint32 bytes;
} T6Region4lang2ti;


#endif /* !__REGION_STRUCT */
